//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.BinaryTransferTest
{
    
    
    /// <summary>
    /// A class that exposes the IBinaryTransferTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class BinaryTransferTestProvider : IFeatureProvider
    {
        
        private IBinaryTransferTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(BinaryTransferTestProvider).Assembly, "BinaryTransferTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public BinaryTransferTestProvider(IBinaryTransferTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        private System.Exception ConvertEchoBinariesObservablyExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "binaries"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinariesObservably/Parame" +
                            "ter/Binaries", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<EchoBinaryValueRequestDto, EchoBinaryValueResponseDto>("EchoBinaryValue", EchoBinaryValue);
            registration.RegisterBinaryCommandParameter("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryValue/Parameter/Bin" +
                    "aryValue");
            registration.RegisterCommandWithIntermediates<EchoBinariesObservablyRequestDto, System.IO.Stream, EchoBinariesObservablyIntermediateDto, System.IO.Stream, EchoBinariesObservablyResponseDto>("EchoBinariesObservably", EchoBinariesObservably, ConvertEchoBinariesObservablyIntermediate, ConvertEchoBinariesObservablyResponse, ConvertEchoBinariesObservablyExceptions);
            registration.RegisterBinaryCommandParameter("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinariesObservably/Parame" +
                    "ter/Binaries");
            registration.RegisterUnobservableCommand<EchoBinaryAndMetadataStringRequestDto, EchoBinaryAndMetadataStringResponseDto>("EchoBinaryAndMetadataString", EchoBinaryAndMetadataString);
            registration.RegisterBinaryCommandParameter("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryAndMetadataString/P" +
                    "arameter/Binary");
            registration.RegisterUnobservableProperty("BinaryValueDirectly", GetBinaryValueDirectly);
            registration.RegisterUnobservableProperty("BinaryValueDownload", GetBinaryValueDownload);
            registration.RegisterMetadata("String", _implementation.String);
        }
        
        /// <summary>
        /// Executes the Echo Binary Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoBinaryValueResponseDto EchoBinaryValue(EchoBinaryValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoBinaryValueResponseDto(_implementation.EchoBinaryValue(request.BinaryValue.TryExtract(_server, "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryValue/Parameter/Bin" +
                                "aryValue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "binaryValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryValue/Parameter/Bin" +
                            "aryValue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        private EchoBinariesObservablyIntermediateDto ConvertEchoBinariesObservablyIntermediate(System.IO.Stream intermediate)
        {
            return new EchoBinariesObservablyIntermediateDto(intermediate, _server);
        }
        
        private EchoBinariesObservablyResponseDto ConvertEchoBinariesObservablyResponse(System.IO.Stream result)
        {
            return new EchoBinariesObservablyResponseDto(result, _server);
        }
        
        /// <summary>
        /// Executes the Echo Binaries Observably command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IIntermediateObservableCommand<System.IO.Stream, System.IO.Stream> EchoBinariesObservably(EchoBinariesObservablyRequestDto request)
        {
            request.Validate();
            return _implementation.EchoBinariesObservably(request.Binaries.TryExtract(_server, "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinariesObservably/Parame" +
                        "ter/Binaries"));
        }
        
        /// <summary>
        /// Executes the Echo Binary And Metadata String command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoBinaryAndMetadataStringResponseDto EchoBinaryAndMetadataString(EchoBinaryAndMetadataStringRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoBinaryAndMetadataStringResponseDto(_implementation.EchoBinaryAndMetadataString(request.Binary.TryExtract(_server, "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryAndMetadataString/P" +
                                "arameter/Binary")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "binary"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryAndMetadataString/P" +
                            "arameter/Binary", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Binary Value Directly property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.BinaryDto> GetBinaryValueDirectly()
        {
            return new PropertyResponse<Tecan.Sila2.BinaryDto>(new Tecan.Sila2.BinaryDto(_implementation.BinaryValueDirectly, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Binary Value Download property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.BinaryDto> GetBinaryValueDownload()
        {
            return new PropertyResponse<Tecan.Sila2.BinaryDto>(new Tecan.Sila2.BinaryDto(_implementation.BinaryValueDownload, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryValue"))
            {
                return typeof(IBinaryTransferTest).GetMethod("EchoBinaryValue");
            }
            if ((commandIdentifier == "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinariesObservably"))
            {
                return typeof(IBinaryTransferTest).GetMethod("EchoBinariesObservably");
            }
            if ((commandIdentifier == "org.silastandard/test/BinaryTransferTest/v1/Command/EchoBinaryAndMetadataString"))
            {
                return typeof(IBinaryTransferTest).GetMethod("EchoBinaryAndMetadataString");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/BinaryTransferTest/v1/Property/BinaryValueDirectly"))
            {
                return typeof(IBinaryTransferTest).GetProperty("BinaryValueDirectly");
            }
            if ((propertyIdentifier == "org.silastandard/test/BinaryTransferTest/v1/Property/BinaryValueDownload"))
            {
                return typeof(IBinaryTransferTest).GetProperty("BinaryValueDownload");
            }
            return null;
        }
    }
    
    /// <summary>
    /// An abstract base class to support the String metadata
    /// </summary>
    public abstract partial class StringInterceptorBase : Tecan.Sila2.Server.IRequestInterceptor
    {
        
        /// <summary>
        /// Gets whether the metadata applies to commands
        /// </summary>
        /// <returns>True, if the metadata is applicable to commands, otherwise false.</returns>
        public abstract bool AppliesToCommands
        {
            get;
        }
        
        /// <summary>
        /// Gets whether the metadata applies to properties
        /// </summary>
        /// <returns>True, if the metadata is applicable to properties, otherwise false.</returns>
        public abstract bool AppliesToProperties
        {
            get;
        }
        
        /// <summary>
        /// Gets the priority for the metadata
        /// </summary>
        /// <returns>A relative priority.</returns>
        public abstract int Priority
        {
            get;
        }
        
        /// <summary>
        /// Gets the metadata identifier this request interceptor is connected to or null, if not applicable
        /// </summary>
        public string MetadataIdentifier
        {
            get
            {
                return "org.silastandard/test/BinaryTransferTest/v1/Metadata/String";
            }
        }
        
        /// <summary>
        /// Decides whether the interceptor is required for the given command
        /// </summary>
        /// <param name="feature">The feature that contains the command or property</param>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <returns>True, if the interceptor should be applied</returns>
        public abstract bool IsInterceptRequired(Feature feature, string commandIdentifier);
        
        /// <summary>
        /// Intercepts the call to the given command
        /// </summary>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <param name="string">The parsed metadata</param>
        /// <returns>A request interception or null, if this is not necessary</returns>
        public abstract Tecan.Sila2.Server.IRequestInterception Intercept(string commandIdentifier, string @string);
        
        /// <summary>
        /// Intercepts the call to the given command
        /// </summary>
        /// <param name="commandIdentifier">The fully qualified identifier of the command or property in question</param>
        /// <param name="server">The server that should execute the request</param>
        /// <param name="metadata">The metadata attached to the request</param>
        /// <returns>A request interception or null, if this is not necessary</returns>
        public Tecan.Sila2.Server.IRequestInterception Intercept(string commandIdentifier, Tecan.Sila2.Server.ISiLAServer server, Tecan.Sila2.Server.IMetadataRepository metadata)
        {
            return Intercept(commandIdentifier, Tecan.Sila2.Server.Metadata.Extract<Tecan.Sila2.StringDto>(metadata, MetadataIdentifier).Extract(server));
        }
    }
}

